<template>
  <SSelect
    v-model="selectedCatalogueType"
    :options="dropdownValues"
    label="Select Catalogue Type"
    class="mb-4"
  />
  <form action="" class="flex flex-col gap-y-4" @submit.prevent="submitSearch">
    <SSearchForm
      v-model="searchQuery"
      placeholder="Search by Cypher query..."
      :autocomplete-options="searchOptionsArray"
      helper-text="Type your custom Cypher query or select from the predefined ones"
    />
    <div v-if="currentParameters?.length">
      <p>Additional parameters:</p>
      <SInput
        v-for="currentParameter in currentParameters"
        :id="currentParameter.key"
        :name="currentParameter.key"
        :label="currentParameter.key"
        v-model="currentParameter.value"
        @keyup.enter="submitSearch"
      />
    </div>
    <div class="flex flex-row">
      <SButton
        icon="search"
        variant="primary"
        type="submit"
        @submit.prevent="submitSearch"
        @click="submitSearch"
        :disabled="isLoading"
        >Search</SButton
      >
      <SLoadingSpinner v-if="isLoading" class="ml-4" />
    </div>
    <div class="self-stretch" v-if="showResults">
      <div class="mb-5 border-t pt-3">
        <p class="mb-1 text-xl text-ec-neutral-180"></p>
        <p class="mb-1 text-xl">
          {{ numberOfResults }} result{{ numberOfResults !== 1 ? 's' : '' }}
          for the query
        </p>
        <p class="text-md font-mono font-semibold text-ec-neutral-180">{{ lastSearchQuery }}</p>
        <div v-if="lastParameters.length">
          with the parameters:
          <p class="ml-4" v-for="parameter in lastParameters" :key="parameter.key">
            <strong>{{ parameter.key }}</strong
            >: {{ parameter.value }}
          </p>
        </div>
      </div>
      <SearchResults :result="result" v-if="result?.length" />
      <div v-else-if="error != null">
        <SStatusMessage title="An error occured during search" variant="error">
          {{ error.message }}
        </SStatusMessage>
      </div>
    </div>
  </form>
</template>

<script setup lang="ts">
import { getPublicEnv } from '@/util/getEnv';
import { computed, ref } from 'vue';
import SearchResults from '../../components/search/SearchResults.vue';
import { searchCatalogue, type FCSearchResult } from '../../services/federatedCatalogue';
import SButton from '../common/SButton.vue';
import SInput from '../common/SInput.vue';
import SLoadingSpinner from '../common/SLoadingSpinner.vue';
import SSearchForm from '../common/SSearchForm.vue';
import SSelect from '../common/SSelect.vue';
import SStatusMessage from '../common/SStatusMessage.vue';

const { PUBLIC_FC_INFRA_URL, PUBLIC_FC_DATA_URL } = getPublicEnv();

export interface SearchParameter {
  key: string;
  value: string;
  type: 'text';
}

interface SearchQueryOption {
  label: string;
  query: string;
  parameters: SearchParameter[];
}

const searchQuery = ref('');
const lastSearchQuery = ref('');
const lastParameters = ref<SearchParameter[]>([]);
const isLoading = ref(false);
const result = ref<FCSearchResult[] | null>(null);
const numberOfResults = ref(0);
const error = ref<{ code: string; message: string } | null>(null);
const showResults = ref(false);

const dropdownValues = ref([
  {
    label: 'Infrastructure Catalogue',
    key: PUBLIC_FC_INFRA_URL,
  },
  {
    label: 'Data Catalogue',
    key: PUBLIC_FC_DATA_URL,
  },
]);

const selectedCatalogueType = ref(PUBLIC_FC_DATA_URL);

const searchOptions = ref<Record<string, SearchQueryOption>>({
  query_1: {
    label: 'Search for the Self-Description that contains the specified substring in the title',
    query: 'MATCH (i)-[r:generalServiceProperties]-(m) WHERE i.title CONTAINS $title RETURN i',
    parameters: [
      {
        key: 'title',
        value: '',
        type: 'text',
      },
    ],
  },
  query_2: {
    label: 'Search for all Self-Description from a specific provider',
    query:
      'MATCH (n)-[r:providerInformation]-(m) WHERE m.provider = $provider MATCH (n)-[:generalServiceProperties]-(i) return i',
    parameters: [
      {
        key: 'provider',
        value: '',
        type: 'text',
      },
    ],
  },
  query_3: {
    label: 'Show only the Self-Description with a price of 0',
    query:
      'MATCH (n)-[r:offeringPrice]-(m) WHERE m.price = "0" MATCH (n)-[:generalServiceProperties]-(i) return i',
    parameters: [],
  },
});

const searchOptionsArray = computed(() =>
  Object.keys(searchOptions.value).map((optionKey) => ({
    key: optionKey,
    label: searchOptions.value[optionKey].label,
    query: searchOptions.value[optionKey].query,
  }))
);

const searchedQueryOption = computed(() => {
  const searchedOptionKey = Object.keys(searchOptions.value).find(
    (optionKey) => searchOptions.value[optionKey].query === searchQuery.value
  );
  return searchedOptionKey ? searchOptions.value[searchedOptionKey] : null;
});

const currentParameters = computed(() =>
  searchedQueryOption.value?.parameters ? searchedQueryOption.value.parameters : []
);

const submitSearch = async () => {
  error.value = null;
  isLoading.value = true;
  showResults.value = false;
  try {
    const data = await searchCatalogue(
      selectedCatalogueType.value,
      searchQuery.value,
      currentParameters.value.reduce((prev, curr) => ({ ...prev, [curr.key]: curr.value }), {})
    );

    result.value = data.items;

    numberOfResults.value = data.totalCount;
  } catch (err: unknown) {
    error.value = { code: 'error', message: (err as Error)?.message ?? 'unkown error' };
    console.error({ err });
  } finally {
    isLoading.value = false;
    showResults.value = true;
    lastSearchQuery.value = searchQuery.value;
    lastParameters.value = [...currentParameters.value.map((p) => ({ ...p }))];
  }
};
</script>
